using System;
using System.Collections.Generic;
using UnityEngine;
using System.Linq;

namespace ToumeiHitsuji
{
public class DiviningRod : MVRScript
{
    protected struct OtherPersonInfo
    {
        public Atom PersonAtom;
        public bool IsFemale;
        public Component MouthTarget;
        public Component VaginaTarget;
        public Component AnusTarget;
        public Component LHandTarget;
        public Component RHandTarget;
        public Trigger MouthTrigger;
        public Trigger VaginaTrigger;
        public Trigger AnusTrigger;
        public Trigger RHandTrigger;
        public Trigger LHandTrigger;
    }
    protected List<OtherPersonInfo> _otherPersons = new List<OtherPersonInfo>();
    protected FreeControllerV3 _penisBase;
    protected FreeControllerV3 _penisMid;
    protected FreeControllerV3 _penisTip;
    protected Rigidbody _gen1;
    protected Rigidbody _gen2;
    protected Rigidbody _gen3;
    protected Rigidbody _pelvis;
    protected Component _penisTarget;
    protected Trigger _targetTrigger;
    protected string _targetType;
    protected Vector3 _targetOffset;
    protected float _targetDistance;
    protected bool _shouldBeInsideTarget;
    protected bool _isInsideTarget;
    protected JSONStorableBool _mouthEnabledJSON = new JSONStorableBool("Mouth Enabled", true);
    protected JSONStorableBool _vaginaEnabledJSON = new JSONStorableBool("Vagina Enabled", true);
    protected JSONStorableBool _anusEnabledJSON = new JSONStorableBool("Anus Enabled", false);
    protected JSONStorableBool _rHandEnabledJSON = new JSONStorableBool("Right Hand Enabled", false);
    protected JSONStorableBool _lHandEnabledJSON = new JSONStorableBool("Left Hand Enabled", false);
    protected JSONStorableBool _femaleEnabledJSON = new JSONStorableBool("Female Enabled", true);
    protected JSONStorableBool _maleEnabledJSON = new JSONStorableBool("Male Enabled", false);
    protected JSONStorableFloat _minTargetDistanceJSON = new JSONStorableFloat("Min Target Distance [cm]", 50f, 0f, 100f, false);
    protected JSONStorableFloat _minRetargetDistanceJSON = new JSONStorableFloat("Min Retarget Distance [cm]", 10f, 0f, 100f, false);
    protected JSONStorableFloat _adaptationRateJSON = new JSONStorableFloat("Adaptation Rate [%/s]", 99.9f, 0f, 100f, true);
    protected JSONStorableFloat _tipForceJSON = new JSONStorableFloat("Force Tip To Target", 0f, 0f, 10f, false);
    protected JSONStorableBool _dynamicAdaptionRateJSON = new JSONStorableBool("Dynamic Adaptation Rate", true);
    protected JSONStorableBool _avoidPopOutJSON = new JSONStorableBool("Avoid Pop Out", false);
    protected JSONStorableBool _verifyWithTriggerJSON = new JSONStorableBool("Verify With Trigger", true);
    protected JSONStorableBool _instantPopBackJSON = new JSONStorableBool("Instant Pop Back", true);
    protected JSONStorableFloat _popOutDetectionThresholdJSON = new JSONStorableFloat("Pop Out Detection Threshold [°]", 10f, 0f, 90f, true);
    protected JSONStorableFloat _mouthOffsetXJSON = new JSONStorableFloat("Mouth Offset X [cm]", 0f, -10f, 10f, false);
    protected JSONStorableFloat _mouthOffsetYJSON = new JSONStorableFloat("Mouth Offset Y [cm]", 0f, -10f, 10f, false);
    protected JSONStorableFloat _mouthOffsetZJSON = new JSONStorableFloat("Mouth Offset Z [cm]", 0f, -10f, 10f, false);
    protected JSONStorableFloat _vaginaOffsetXJSON = new JSONStorableFloat("Vagina Offset X [cm]", 0f, -10f, 10f, false);
    protected JSONStorableFloat _vaginaOffsetYJSON = new JSONStorableFloat("Vagina Offset Y [cm]", 0f, -10f, 10f, false);
    protected JSONStorableFloat _vaginaOffsetZJSON = new JSONStorableFloat("Vagina Offset Z [cm]", 0f, -10f, 10f, false);
    protected JSONStorableFloat _anusOffsetXJSON = new JSONStorableFloat("Anus Offset X [cm]", 0f, -10f, 10f, false);
    protected JSONStorableFloat _anusOffsetYJSON = new JSONStorableFloat("Anus Offset Y [cm]", 0.3f, -10f, 10f, false);
    protected JSONStorableFloat _anusOffsetZJSON = new JSONStorableFloat("Anus Offset Z [cm]", -3f, -10f, 10f, false);
    protected JSONStorableFloat _handOffsetXJSON = new JSONStorableFloat("Hand Offset X [cm]", 7f, -10f, 10f, false);
    protected JSONStorableFloat _handOffsetYJSON = new JSONStorableFloat("Hand Offset Y [cm]", -1.6f, -10f, 10f, false);
    protected JSONStorableFloat _handOffsetZJSON = new JSONStorableFloat("Hand Offset Z [cm]", 2f, -10f, 10f, false);
    protected JSONStorableFloat _customTargetOffsetXJSON = new JSONStorableFloat("Custom Target Offset X [cm]", 0f, -10f, 10f, false);
    protected JSONStorableFloat _customTargetOffsetYJSON = new JSONStorableFloat("Custom Target Offset Y [cm]", 0f, -10f, 10f, false);
    protected JSONStorableFloat _customTargetOffsetZJSON = new JSONStorableFloat("Custom Target Offset Z [cm]", 0f, -10f, 10f, false);
    protected JSONStorableStringChooser _customTargetAtomChooser;
    protected UIDynamicPopup _customTargetAtomPopup;
    protected JSONStorableStringChooser _customTargetChooser;
    protected UIDynamicPopup _customTargetPopup;
    protected Atom _customTargetAtom = null;
    protected Component _customTarget = null;

    protected void syncCustomTarget()
    {
        if (_penisTarget == _customTarget)
        {
            _penisTarget = null; // reset
        }
        if (string.IsNullOrEmpty(_customTargetAtomChooser.val) || _customTargetAtomChooser.val == "None")
        {
            _customTargetAtom = null;
            _customTarget = null;
        }
        else
        {
            _customTargetAtom = SuperController.singleton.GetAtomByUid(_customTargetAtomChooser.val);
            if (string.IsNullOrEmpty(_customTargetChooser.val) || _customTargetChooser.val == "None")
            {
                _customTarget = null;
            }
            else
            {
                _customTarget = _customTargetAtom.rigidbodies.FirstOrDefault(rb => rb.name == _customTargetChooser.val);
            }
        }
    }

    protected List<string> getCustomTargetAtomChoices()
    {
        List<string> choices = new List<string>{"None"};
        choices.AddRange(SuperController.singleton.GetAtomUIDsWithRigidbodies());
        return choices;
    }

    protected List<string> getCustomTargetChoices()
    {
        List<string> choices = new List<string>{"None"};
        if (!string.IsNullOrEmpty(_customTargetAtomChooser.val) && _customTargetAtomChooser.val != "None")
        {
            choices.AddRange(SuperController.singleton.GetRigidbodyNamesInAtom(_customTargetAtomChooser.val)); 
        }
        return choices;
    }

    protected void syncOtherPersonAtoms()
    {
        _penisTarget = null; // reset target
        if (!(_maleEnabledJSON.val || _femaleEnabledJSON.val))
        {
            _otherPersons = new List<OtherPersonInfo>(); // empty list
        }
        else
        {
            List<Atom> otherPersonAtoms;
            otherPersonAtoms = SuperController.singleton.GetAtoms().Where(atom => atom.type == "Person" && atom != containingAtom).ToList();
            if (_femaleEnabledJSON.val && !_maleEnabledJSON.val)
            {
                otherPersonAtoms = otherPersonAtoms.Where(atom => IsFemale(atom)).ToList();
            }
            else if (!_femaleEnabledJSON.val && _maleEnabledJSON.val)
            {
                otherPersonAtoms = otherPersonAtoms.Where(atom => !IsFemale(atom)).ToList();
            }
            _otherPersons.Clear();
            foreach (Atom personAtom in otherPersonAtoms)
            {
                OtherPersonInfo personInfo;
                personInfo.PersonAtom = personAtom;
                personInfo.IsFemale = IsFemale(personAtom);
                personInfo.MouthTarget = personAtom.rigidbodies.First(rb => rb.name == "LipTrigger");
                personInfo.VaginaTarget = personAtom.rigidbodies.First(rb => rb.name == "LabiaTrigger");
                personInfo.AnusTarget = personInfo.VaginaTarget;
                personInfo.RHandTarget = personAtom.rigidbodies.First(rb => rb.name == "rHand");
                personInfo.LHandTarget = personAtom.rigidbodies.First(rb => rb.name == "lHand");
                personInfo.MouthTrigger = personAtom.rigidbodies.First(rb => rb.name == "MouthTrigger").GetComponent<CollisionTrigger>().trigger;
                personInfo.VaginaTrigger = personAtom.rigidbodies.First(rb => rb.name == "VaginaTrigger").GetComponent<CollisionTrigger>().trigger;
                personInfo.AnusTrigger = personInfo.VaginaTrigger;
                personInfo.RHandTrigger = null;
                personInfo.LHandTrigger = null;
                _otherPersons.Add(personInfo);
            }
        }
    }

    public override void Init()
    {
        try
        {
            _mouthEnabledJSON.storeType = JSONStorableParam.StoreType.Full;
            _mouthEnabledJSON.setCallbackFunction += (bool isChecked) => {
                if (_targetType == "Mouth" && !isChecked)
                {
                    _penisTarget = null;
                }
            };
            RegisterBool(_mouthEnabledJSON);
            CreateToggle(_mouthEnabledJSON, false);

            _vaginaEnabledJSON.storeType = JSONStorableParam.StoreType.Full;
            _vaginaEnabledJSON.setCallbackFunction += (bool isChecked) => {
                if (_targetType == "Vagina" && !isChecked)
                {
                    _penisTarget = null;
                }
            };
            RegisterBool(_vaginaEnabledJSON);
            CreateToggle(_vaginaEnabledJSON, false);
            
            _anusEnabledJSON.storeType = JSONStorableParam.StoreType.Full;
            _anusEnabledJSON.setCallbackFunction += (bool isChecked) => {
                if (_targetType == "Anus" && !isChecked)
                {
                    _penisTarget = null;
                }
            };
            RegisterBool(_anusEnabledJSON);
            CreateToggle(_anusEnabledJSON, false);

            _rHandEnabledJSON.storeType = JSONStorableParam.StoreType.Full;
            _rHandEnabledJSON.setCallbackFunction += (bool isChecked) => {
                if (_targetType == "rHand" && !isChecked)
                {
                    _penisTarget = null;
                }
            };
            RegisterBool(_rHandEnabledJSON);
            CreateToggle(_rHandEnabledJSON, false);

            _lHandEnabledJSON.storeType = JSONStorableParam.StoreType.Full;
            _lHandEnabledJSON.setCallbackFunction += (bool isChecked) => {
                if (_targetType == "lHand" && !isChecked)
                {
                    _penisTarget = null;
                }
            };
            RegisterBool(_lHandEnabledJSON);
            CreateToggle(_lHandEnabledJSON, false);

            UIDynamicTextField text = CreateTextField(new JSONStorableString("text",
                "Targets orifices." +
                "\n\n<b>Note:</b> Anus and hands are a bit more likely to need manual tweaking of offsets. " +
                "See advanced options further below."
                ), true);
            text.height = 310f;

            CreateSpacer(false).height = 20f;
            CreateSpacer(true).height = 20f;

            _femaleEnabledJSON.storeType = JSONStorableParam.StoreType.Full;
            _femaleEnabledJSON.setCallbackFunction += (bool isChecked) => syncOtherPersonAtoms();
            RegisterBool(_femaleEnabledJSON);
            CreateToggle(_femaleEnabledJSON, false);

            _maleEnabledJSON.storeType = JSONStorableParam.StoreType.Full;
            _maleEnabledJSON.setCallbackFunction += (bool isChecked) => syncOtherPersonAtoms();
            RegisterBool(_maleEnabledJSON);
            CreateToggle(_maleEnabledJSON, false);

            text = CreateTextField(new JSONStorableString("text", "Target genders."), true);
            text.height = 115f;

            CreateSpacer(false).height = 30f;
            CreateSpacer(true).height = 30f;

            UIDynamicButton button = CreateButton("Below are <b>Advanced Options</b>...", false);
            button.buttonColor = new Color(0.9f, 0.9f, 0.6f);
            button.enabled = false;
            button = CreateButton("...you rarely actually need them.", true);
            button.buttonColor = new Color(0.9f, 0.9f, 0.6f);
            button.enabled = false;
			
			CreateSpacer(false).height = 10f;
            CreateSpacer(true).height = 10f;

            _customTargetAtomChooser = new JSONStorableStringChooser("customTargetAtom",
                getCustomTargetAtomChoices(), "None", "Custom Target Atom", (string name) => {
                    _customTargetChooser.SetVal("None");
                    syncCustomTarget();
                });
            RegisterStringChooser(_customTargetAtomChooser);
            _customTargetAtomPopup = CreateFilterablePopup(_customTargetAtomChooser);
            _customTargetAtomPopup.popup.onOpenPopupHandlers += () =>
            {
                _customTargetAtomChooser.choices = getCustomTargetAtomChoices();
            };

            _customTargetChooser = new JSONStorableStringChooser("customTarget",
                getCustomTargetChoices(), "None", "Custom Target", (string name) => syncCustomTarget());
            RegisterStringChooser(_customTargetChooser);
            _customTargetPopup = CreateFilterablePopup(_customTargetChooser);
            _customTargetPopup.popup.onOpenPopupHandlers += () =>
            {
                _customTargetChooser.choices = getCustomTargetChoices();
            };

            text = CreateTextField(new JSONStorableString("text", "An additional custom target that can be anything."), true);
            text.height = 255f;

            CreateSpacer(false).height = 20f;
            CreateSpacer(true).height = 20f;

            _minTargetDistanceJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_minTargetDistanceJSON);
            CreateSlider(_minTargetDistanceJSON, false);

            text = CreateTextField(new JSONStorableString("text", "Minimum distance at which to start targeting. Measured from penis tip."), true);
            text.height = 120f;

            _minRetargetDistanceJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_minRetargetDistanceJSON);
            CreateSlider(_minRetargetDistanceJSON, false);

            text = CreateTextField(new JSONStorableString("text", "Minimum distance current target needs to be away before a new target may be considered."), true);
            text.height = 120f;

            CreateSpacer(false).height = 20f;
            CreateSpacer(true).height = 20f;

            _adaptationRateJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_adaptationRateJSON);
            CreateSlider(_adaptationRateJSON, false);

            _dynamicAdaptionRateJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterBool(_dynamicAdaptionRateJSON);
            CreateToggle(_dynamicAdaptionRateJSON, false);

            text = CreateTextField(new JSONStorableString("text",
                "Percentage of adaptation per second (100 = instant). " +
                "If dynamic adaptation rate is on, the effective rate will be 0 " +
                "at \"Min Target Distance\", and reach the given value at " +
                "\"Min Retarget Distance\"."
                ), true);
            text.height = 185f;

            CreateSpacer(false).height = 20f;
            CreateSpacer(true).height = 20f;

            _avoidPopOutJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterBool(_avoidPopOutJSON);
            CreateToggle(_avoidPopOutJSON, false);

            _popOutDetectionThresholdJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_popOutDetectionThresholdJSON);
            CreateSlider(_popOutDetectionThresholdJSON, false);

            _verifyWithTriggerJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterBool(_verifyWithTriggerJSON);
            CreateToggle(_verifyWithTriggerJSON, false);

            _instantPopBackJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterBool(_instantPopBackJSON);
            CreateToggle(_instantPopBackJSON, false);

            text = CreateTextField(new JSONStorableString("text",
                "<b>(Experimental)</b> Active penis pop out prevention. " +
                "Will briefly disable penis collision if pop out is detected. " +
                "The detection threshold is based on the angle between penis and target. " +
                "\"Verify With Trigger\" will make the detection much more stable (recommended), " +
                "but will limit pop out prevention to mouth, vagina, and anus. " +
                "It will then also not count as a pop out if you just get into the wrong hole. " +
                "\"Instant Pop Back\" will fix adaptation rate to 100 during pop back."
                ), true);
            text.height = 315f;

            CreateSpacer(false).height = 20f;
            CreateSpacer(true).height = 20f;

            _tipForceJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_tipForceJSON);
            CreateSlider(_tipForceJSON, false);

            text = CreateTextField(new JSONStorableString("text",
                "<b>(Experimental)</b> An additional continuous force and torque on the penis tip towards the target. " +
                "Can help sliding it in at particular steep angles."
                ), true);
            text.height = 120f;

            CreateSpacer(false).height = 20f;
            CreateSpacer(true).height = 20f;

            _mouthOffsetXJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_mouthOffsetXJSON);
            CreateSlider(_mouthOffsetXJSON, false);
            _mouthOffsetYJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_mouthOffsetYJSON);
            CreateSlider(_mouthOffsetYJSON, false);
            _mouthOffsetZJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_mouthOffsetZJSON);
            CreateSlider(_mouthOffsetZJSON, false);

            text = CreateTextField(new JSONStorableString("text",
                "Mouth target position relative to LipTrigger.\n" +
                "\nX: right from the view of the target." +
                "\nY: up towards nose." + 
                "\nZ: forward outside of mouth."
                ), true);
            text.height = 390f;

            CreateSpacer(false).height = 20f;
            CreateSpacer(true).height = 20f;

            _vaginaOffsetXJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_vaginaOffsetXJSON);
            CreateSlider(_vaginaOffsetXJSON, false);
            _vaginaOffsetYJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_vaginaOffsetYJSON);
            CreateSlider(_vaginaOffsetYJSON, false);
            _vaginaOffsetZJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_vaginaOffsetZJSON);
            CreateSlider(_vaginaOffsetZJSON, false);

            text = CreateTextField(new JSONStorableString("text",
                "Vagina target position relative to LabiaTrigger.\n" +
                "\nX: right from the view of the target." +
                "\nY: up into vagina." + 
                "\nZ: forward towards belly."
                ), true);
            text.height = 390f;

            CreateSpacer(false).height = 20f;
            CreateSpacer(true).height = 20f;

            _anusOffsetXJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_anusOffsetXJSON);
            CreateSlider(_anusOffsetXJSON, false);
            _anusOffsetYJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_anusOffsetYJSON);
            CreateSlider(_anusOffsetYJSON, false);
            _anusOffsetZJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_anusOffsetZJSON);
            CreateSlider(_anusOffsetZJSON, false);

            text = CreateTextField(new JSONStorableString("text",
                "Anus target position relative to <b>LabiaTrigger</b>.\n" +
                "\nX: right from the view of the target." +
                "\nY: up into vagina." + 
                "\nZ: forward towards belly."
                ), true);
            text.height = 390f;

            CreateSpacer(false).height = 20f;
            CreateSpacer(true).height = 20f;

            _handOffsetXJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_handOffsetXJSON);
            CreateSlider(_handOffsetXJSON, false);
            _handOffsetYJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_handOffsetYJSON);
            CreateSlider(_handOffsetYJSON, false);
            _handOffsetZJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_handOffsetZJSON);
            CreateSlider(_handOffsetZJSON, false);

            text = CreateTextField(new JSONStorableString("text",
                "Hand target position relative to rHand/lHand rigidbody " +
                "(origin is near wrists).\n" +
                "\nX: Towards fingers." +
                "\nY: Towards back of the hand." + 
                "\nZ: Towards thumb."
                ), true);
            text.height = 390f;

            CreateSpacer(false).height = 20f;
            CreateSpacer(true).height = 20f;

            _customTargetOffsetXJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_customTargetOffsetXJSON);
            CreateSlider(_customTargetOffsetXJSON, false);
            _customTargetOffsetYJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_customTargetOffsetYJSON);
            CreateSlider(_customTargetOffsetYJSON, false);
            _customTargetOffsetZJSON.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(_customTargetOffsetZJSON);
            CreateSlider(_customTargetOffsetZJSON, false);

            text = CreateTextField(new JSONStorableString("text",
                "Offset from custom target.\n" +
                "\nX: Custom target local x axis." +
                "\nY: Custom target local y axis." + 
                "\nZ: Custom target local z axis."
                ), true);
            text.height = 390f;

            _penisTarget = null;
            _targetOffset = new Vector3(0f, 0f, 0f);
            syncOtherPersonAtoms();
            _pelvis = containingAtom.rigidbodies.First(rb => rb.name == "pelvis");
            _penisBase = containingAtom.freeControllers.First(fc => fc.name == "penisBaseControl");
            _penisMid = containingAtom.freeControllers.First(fc => fc.name == "penisMidControl");
            _penisTip = containingAtom.freeControllers.First(fc => fc.name == "penisTipControl");
            _penisBase.currentPositionState = FreeControllerV3.PositionState.Off;
            _penisMid.currentPositionState = FreeControllerV3.PositionState.Off;
            _penisTip.currentPositionState = FreeControllerV3.PositionState.Off;
            _gen1 = containingAtom.rigidbodies.First(rb => rb.name == "Gen1");
            _gen2 = containingAtom.rigidbodies.First(rb => rb.name == "Gen2");
            _gen3 = containingAtom.rigidbodies.First(rb => rb.name == "Gen3");
            //SuperController.LogMessage($"{nameof(DiviningRod)} initialized");
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningRod)}.{nameof(Init)}: {e}");
        }
    }

    public void OnEnable()
    {
        try
        {
            _penisTarget = null;
            syncOtherPersonAtoms();
            //SuperController.LogMessage($"{nameof(DiviningRod)} enabled");
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningRod)}.{nameof(OnEnable)}: {e}");
        }
    }

    public void OnDisable()
    {
        try
        {
            _gen1.detectCollisions = true;
            _gen2.detectCollisions = true;
            _gen3.detectCollisions = true;
            //SuperController.LogMessage($"{nameof(DiviningRod)} disabled");
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningRod)}.{nameof(OnDisable)}: {e}");
        }
    }

    public void OnDestroy()
    {
        try
        {
            _gen1.detectCollisions = true;
            _gen2.detectCollisions = true;
            _gen3.detectCollisions = true;
            //SuperController.LogMessage($"{nameof(DiviningRod)} destroyed");
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningRod)}.{nameof(OnDestroy)}: {e}");
        }
    }

    public static bool IsFemale(Atom person)
    {
        bool retVal = true;
        DAZCharacter character = person.GetComponentInChildren<DAZCharacter>();
        if (character != null)
        {
            retVal = !character.isMale;
        }
        return retVal;
    }

    public Vector3 GetOffset(string targetType)
    {
        Vector3 offset = new Vector3(0f, 0f, 0f);
        if (targetType == "Mouth")
        {
            offset = new Vector3( _mouthOffsetXJSON.val, _mouthOffsetYJSON.val, _mouthOffsetZJSON.val);
        }
        else if (targetType == "Vagina")
        {
            offset =  new Vector3(_vaginaOffsetXJSON.val, _vaginaOffsetYJSON.val, _vaginaOffsetZJSON.val);
        }
        else if (targetType == "Anus")
        {
            offset =  new Vector3(_anusOffsetXJSON.val, _anusOffsetYJSON.val, _anusOffsetZJSON.val);
        }
        else if (targetType == "rHand")
        {
            offset =  new Vector3(_handOffsetXJSON.val, _handOffsetYJSON.val, _handOffsetZJSON.val);
        }
        else if (targetType == "lHand")
        {
            // swap x axis for left hand
            offset =  new Vector3(-_handOffsetXJSON.val, _handOffsetYJSON.val, _handOffsetZJSON.val);
        }
        else if (targetType == "Custom")
        {
            offset =  new Vector3(_customTargetOffsetXJSON.val, _customTargetOffsetYJSON.val, _customTargetOffsetZJSON.val);
        }
        return offset * 0.01f; // cm to m
    }

    public bool IsInFront(Component target, Vector3 offset)
    {
        // TODO: Configurable Max Angle
        return Vector3.Dot(target.transform.TransformPoint(offset) - _pelvis.transform.position, _pelvis.transform.forward) > 0.0f;    
    }

    protected void potentialTargetUpdate(Component potentialTarget, string targetType, Trigger trigger=null)
    {
        Vector3 targetOffset = GetOffset(targetType);
        float targetDistance = (_penisTip.transform.position - potentialTarget.transform.TransformPoint(targetOffset)).magnitude;
        bool targetWithinDistance = (targetDistance < _minTargetDistanceJSON.val * 0.01f) || (_minTargetDistanceJSON.val <= 0f);
        bool targetIsNearer = true;
        if (_penisTarget != null)
        {
            targetIsNearer = targetDistance < (_penisTip.transform.position - _penisTarget.transform.TransformPoint(_targetOffset)).magnitude;
        }

        if (IsInFront(potentialTarget, targetOffset) && targetWithinDistance && targetIsNearer)
        {
            _penisTarget = potentialTarget;
            _targetOffset = targetOffset;
            _targetDistance = targetDistance;
            _targetType = targetType;
            _targetTrigger = trigger;
        }
    }

    protected void syncInsideState()
    {
        if (_penisTarget != null)
        {
            _shouldBeInsideTarget = Vector3.Dot(_penisTarget.transform.TransformPoint(_targetOffset) - _penisTip.transform.position, _penisTip.transform.forward) <= 0.0f;
            _isInsideTarget = _shouldBeInsideTarget;
            if (_targetTrigger != null)
            {
                _isInsideTarget = _isInsideTarget && _targetTrigger.active;
            }
        }
    }

    protected void syncPenisTarget()
    {
        //if (!(_mouthEnabledJSON.val || _vaginaEnabledJSON.val || _anusEnabledJSON.val || _rHandEnabledJSON.val || _lHandEnabledJSON.val) && _customTarget == null)
        //{
        //    _penisTarget = null;
        //    return;
        //}

        if (_penisTarget != null)
        {
            _targetDistance = (_penisTip.transform.position - _penisTarget.transform.TransformPoint(_targetOffset)).magnitude;
            _targetOffset = GetOffset(_targetType); // need to update offset if changed interactively
            syncInsideState();
            if (!_isInsideTarget) // only consider retargeting outside of target
            {
                if (_targetDistance > _minRetargetDistanceJSON.val * 0.01f || !IsInFront(_penisTarget, _targetOffset))
                {
                    _penisTarget = null;
                }
            }
        }

        if (_penisTarget == null)
        {
            _targetTrigger = null;
            foreach (OtherPersonInfo personInfo in _otherPersons)
            {
                if (_mouthEnabledJSON.val)
                {
                    potentialTargetUpdate(personInfo.MouthTarget, "Mouth", personInfo.MouthTrigger);
                }
                if (_vaginaEnabledJSON.val && personInfo.IsFemale)
                {
                    potentialTargetUpdate(personInfo.VaginaTarget, "Vagina", personInfo.VaginaTrigger);
                }
                if (_anusEnabledJSON.val)
                {
                    potentialTargetUpdate(personInfo.AnusTarget, "Anus", personInfo.AnusTrigger);
                }
                if (_rHandEnabledJSON.val)
                {
                    potentialTargetUpdate(personInfo.RHandTarget, "rHand", personInfo.RHandTrigger);
                }
                if (_lHandEnabledJSON.val)
                {
                    potentialTargetUpdate(personInfo.LHandTarget, "lHand", personInfo.LHandTrigger);
                }
            }
            if (_customTarget != null)
            {
                potentialTargetUpdate(_customTarget, "Custom");
            }
            syncInsideState();
        }
    }

    // FixedUpdate is called with each physics simulation frame by Unity
    void FixedUpdate()
    {
        try
        {
            syncPenisTarget();

            // reset detections which might have been turned of by pop out prevention previously
            _gen1.detectCollisions = true;
            _gen2.detectCollisions = true;
            _gen3.detectCollisions = true;

            if (_adaptationRateJSON.val == 0f)
            {
                return;
            }

            if (_penisTarget == null)
            {
                _penisBase.currentRotationState = FreeControllerV3.RotationState.Off;
                _penisMid.currentRotationState = FreeControllerV3.RotationState.Off;
                _penisTip.currentRotationState = FreeControllerV3.RotationState.Off;
                return;
            }
            
            _penisBase.currentRotationState = FreeControllerV3.RotationState.On;
            _penisMid.currentRotationState = FreeControllerV3.RotationState.On;
            _penisTip.currentRotationState = FreeControllerV3.RotationState.Comply;   

            // when we are inside the target, we want the penis to be more influenced by physics
            if (_isInsideTarget)
            {
                if (!(_targetType.EndsWith("Hand") || _targetType == "Custom"))
                {
                    _penisBase.currentRotationState = FreeControllerV3.RotationState.Comply;
                    _penisMid.currentRotationState = FreeControllerV3.RotationState.Off;
                    _penisTip.currentRotationState = FreeControllerV3.RotationState.Off;
                }
                else
                {
                    _penisBase.currentRotationState = FreeControllerV3.RotationState.Comply;
                    _penisMid.currentRotationState = FreeControllerV3.RotationState.Comply;
                    _penisTip.currentRotationState = FreeControllerV3.RotationState.Comply;
                }
            }
            
            // apply transform to base
            Quaternion oldRotation = _penisBase.transform.rotation;
            _penisBase.transform.LookAt(_penisTarget.transform.TransformPoint(_targetOffset), _pelvis.transform.up);

            // avoid pop out
            bool popOutDetected = _avoidPopOutJSON.val &&
                ((_verifyWithTriggerJSON.val && _isInsideTarget != _shouldBeInsideTarget) || (!_verifyWithTriggerJSON.val && _shouldBeInsideTarget)) &&
                Quaternion.Angle(_gen1.transform.rotation, _penisBase.transform.rotation) > _popOutDetectionThresholdJSON.val;
            if (popOutDetected)
            {
                //SuperController.LogMessage($"{nameof(DiviningRod)}.{nameof(FixedUpdate)}: Attempting to avoid penis pop out.");
                // will be set back to true in next fixed update
                _gen1.detectCollisions = false;
                _gen2.detectCollisions = false;
                _gen3.detectCollisions = false;
            }

            // apply adaptation rate
            if (!(popOutDetected && _instantPopBackJSON.val))
            {
                float adaptationRate = _adaptationRateJSON.val;
                if (_dynamicAdaptionRateJSON.val && _minRetargetDistanceJSON.val < _minTargetDistanceJSON.val && !_isInsideTarget)
                {
                    float minTargetDistance = _minTargetDistanceJSON.val * 0.01f;
                    float minRetargetDistance = _minRetargetDistanceJSON.val * 0.01f;
                    float distanceFac = Mathf.Clamp((_targetDistance - minRetargetDistance) / (minTargetDistance - minRetargetDistance), 0f, 1f);
                    adaptationRate *= 1f - distanceFac*distanceFac;
                }
                if (adaptationRate < 100f)
                {
                    // exponential ease
                    float lerpFac = Mathf.Pow(1f - adaptationRate*0.01f, Time.fixedDeltaTime);
                    _penisBase.transform.rotation = Quaternion.Lerp(_penisBase.transform.rotation, oldRotation, lerpFac);
                }
            }

            // apply transform from base to other penis parts
            _penisMid.transform.rotation=_penisBase.transform.rotation;
            _penisTip.transform.rotation=_penisBase.transform.rotation;
            
            // apply tip force
            if (_tipForceJSON.val > 0 && !_isInsideTarget)
            {
                Vector3 forceVec = (_penisTarget.transform.position - _penisTip.transform.position).normalized;
                // angularFalloff -> smaller force, if tip direction is already aligned with target or even behind it
                float angularFalloff = 1f - Mathf.Abs(Vector3.Dot(forceVec, _penisTip.transform.forward));
                float forceIntesity = _tipForceJSON.val;
                forceIntesity *= angularFalloff;
                _gen3.AddForce(forceVec * forceIntesity, ForceMode.VelocityChange);

                Vector3 torqueVec = Vector3.Cross(_penisTip.transform.forward, forceVec);
                float torqueIntensity = _tipForceJSON.val;
                torqueIntensity *= angularFalloff;
                _gen3.AddTorque(torqueVec * torqueIntensity, ForceMode.Force);
            }
        }
        catch (Exception e)
        {
            SuperController.LogError($"{nameof(DiviningRod)}.{nameof(FixedUpdate)}: {e}");
        }
    }
}

} // namespace ToumeiHitsuji end
